using System;
using System.Net;
using System.Windows.Forms;

using Smdn.Windows.Forms;

namespace Smdn.Applications.SimpleMailer {
  public class PasswordInputCredential : ICredentialsByHost, ICredentials {
    public PasswordInputCredential(string username, IWin32Window owner)
    {
      this.username = username;
    }

    public NetworkCredential GetCredential(string host, int port, string authType)
    {
      if (credential == null) {
        using (var dialog = new InputDialog()) {
          dialog.UseSystemPasswordChar = true;
          dialog.Description = string.Format("ホスト '{0}'、ユーザ '{1}'のパスワードを入力してください。", host, username);

          if (dialog.ShowDialog(owner) == DialogResult.OK)
            credential = new NetworkCredential(username, dialog.InputText, host);
          else
            credential = new NetworkCredential(username, null, host);
        }
      }

      return credential;
    }

    public NetworkCredential GetCredential(Uri uri, string authType)
    {
      throw new NotImplementedException();
    }

    private string username;
    private IWin32Window owner;
    private NetworkCredential credential = null;
  }
}
