using System;
using System.Collections.Generic;
using System.Net;

using Smdn.Net.Pop3;
using Smdn.Net.Pop3.Client;

namespace Smdn.Applications.SimpleMailer {
  public class PopAccount : AccountBase {
    public PopClient Client {
      get { return client; }
    }

    public bool ReadOnly {
      get; private set;
    }

    public PopAccount(string name, Uri serverUri, ICredentialsByHost credential, int timeout, bool useTlsIfAvailable)
      : base(name, serverUri)
    {
      this.client = new PopClient(serverUri);
      this.credential = credential;

      this.client.Profile.Timeout = timeout;
      this.client.Profile.UseTlsIfAvailable = useTlsIfAvailable;
    }

    public override void EnsureConnected()
    {
      if (client.IsConnected)
        return;

      client.Connect(credential);

      this.credential = null;
    }

    private PopClient client;
    private ICredentialsByHost credential;
  }
}
